﻿using Syncfusion.Windows.Forms.Grid;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WindowsFormsApplication13
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            this.gridDataBoundGrid1.CurrentCellShowedDropDown += gridDataBoundGrid1_CurrentCellShowedDropDown;
        }

        void gridDataBoundGrid1_CurrentCellShowedDropDown(object sender, EventArgs e)
        {
          
            GridCurrentCell cc = this.gridDataBoundGrid1.CurrentCell;
            DataTable dtItms = (DataTable)this.gridDataBoundGrid1[cc.RowIndex, cc.ColIndex].DataSource;
            if (cc.ColIndex == 2) //Country2
            {
                DataTable dtCmb3 = new DataTable();
                DataTable dtMerge = new DataTable();
                string str1 = this.gridDataBoundGrid1[cc.RowIndex, cc.ColIndex - 1].FormattedText; //dgvwDtls.Rows[e.RowIndex].Cells["Column1"].EditedFormattedValue.ToString();
                DataRow[] drary = dtItms.Select("Name <> '" + str1 + "'");
                dtMerge = drary.CopyToDataTable();
                dtCmb3.Merge(dtMerge);
               // DataGridViewComboBoxCell dgvcmb1 = (DataGridViewComboBoxCell)dgvwDtls.Rows[dgvwDtls.CurrentCell.RowIndex].Cells["Column2"];
                GridComboBoxCellRenderer renderer = cc.Renderer as GridComboBoxCellRenderer; // this.gridDataBoundGrid1[cc.RowIndex, cc.ColIndex];
                renderer.ListBoxPart.DataSource = dtCmb3;
                //dgvcmb1.ResetDataSource();
                //dgvcmb1.DataSource = dtCmb3;
                renderer.ListBoxPart.ValueMember = "cntry_Id";
                renderer.ListBoxPart.DisplayMember = "Name";

            }
            else if (cc.ColIndex == 3)
            {
                DataTable dtCmb3 = new DataTable();
                DataTable dtMerge = new DataTable();
                string str1 = this.gridDataBoundGrid1[cc.RowIndex, cc.ColIndex - 1].FormattedText;
                string str2 = this.gridDataBoundGrid1[cc.RowIndex, cc.ColIndex -2].FormattedText;
                DataRow[] drary = dtItms.Select("Name <> '" + str1 + "' AND Name <> '" + str2 + "'");
                dtMerge = drary.CopyToDataTable();
                dtCmb3.Merge(dtMerge);
             
                GridComboBoxCellRenderer renderer = cc.Renderer as GridComboBoxCellRenderer; // this.gridDataBoundGrid1[cc.RowIndex, cc.ColIndex];
                renderer.ListBoxPart.DataSource = dtCmb3;
                renderer.ListBoxPart.ValueMember = "cntry_Id";
                renderer.ListBoxPart.DisplayMember = "Name";

            }


        }
        DataTable table = new DataTable();
        private void Form1_Load(object sender, System.EventArgs e)
        {
            this.gridDataBoundGrid1.DataSource = PrimaryTable();
         

            FillGridView();
           

            
            GridBoundColumn gbc1 = this.gridDataBoundGrid1.Binder.InternalColumns[0];
            gbc1.StyleInfo.DataSource = table;
            gbc1.StyleInfo.CellType = "ComboBox";
            gbc1.StyleInfo.DisplayMember = "Name";
            gbc1.StyleInfo.ValueMember = "cntry_Id";
            gbc1.StyleInfo.ShowButtons = GridShowButtons.ShowCurrentRow;
            gbc1.StyleInfo.HorizontalAlignment = GridHorizontalAlignment.Left;


            GridBoundColumn gbc2 = this.gridDataBoundGrid1.Binder.InternalColumns[1];
            gbc2.StyleInfo.DataSource = table;
            gbc2.StyleInfo.CellType = "ComboBox";
            gbc2.StyleInfo.DisplayMember = "Name";
            gbc2.StyleInfo.ValueMember = "cntry_Id";
            gbc2.StyleInfo.ShowButtons = GridShowButtons.ShowCurrentRow;
            gbc2.StyleInfo.HorizontalAlignment = GridHorizontalAlignment.Left;

            GridBoundColumn gbc3 = this.gridDataBoundGrid1.Binder.InternalColumns[2];
            gbc3.StyleInfo.DataSource = table;
            gbc3.StyleInfo.CellType = "ComboBox";
            gbc3.StyleInfo.DisplayMember = "Name";
            gbc3.StyleInfo.ValueMember = "cntry_Id";
            gbc3.StyleInfo.ShowButtons = GridShowButtons.ShowCurrentRow;
            gbc3.StyleInfo.HorizontalAlignment = GridHorizontalAlignment.Left;

        }

       

            private void FillGridView()
            {
                table.Columns.Add("cntry_Id", typeof(int));
                table.Columns.Add("Name", typeof(string));
                table.Rows.Add(1, "UK");
                table.Rows.Add(2, "IN");
                table.Rows.Add(3, "US");
                table.Rows.Add(4, "Australia");
                table.Rows.Add(5, "Africa");
                table.Rows.Add(6, "Italy");
                table.Rows.Add(7, "Spain");
                table.Rows.Add(8, "France");
                table.TableName = "Country";
            }


            private DataTable PrimaryTable()
            {
                DataTable table = new DataTable("PrimaryTable");
                table.Columns.Add(new DataColumn("Country1"));
                table.Columns.Add(new DataColumn("Country2"));
                table.Columns.Add(new DataColumn("Country3"));
                
                return table;
            }

       

      


    }
}
